apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ jicofo_name }}
  name: {{ jicofo_name }}
  namespace: {{ namespace }}
spec:
  replicas: {{ jicofo_replicas }}
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ jicofo_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ jicofo_name }}
  strategy:
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ jicofo_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ jicofo_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ jicofo_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: JICOFO_AUTH_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ jicofo_name }}
        - name: JICOFO_AUTH_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ jicofo_name }}
        - name: JICOFO_COMPONENT_SECRET
          valueFrom:
            secretKeyRef:
              key: component-secret
              name: {{ jitsi_name }}
        - name: JVB_BREWERY_MUC
          value: jvbbrewery
        - name: TZ
          value: {{ timezone }}
        - name: XMPP_AUTH_DOMAIN
          value: auth.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_DOMAIN
          value: meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_INTERNAL_MUC_DOMAIN
          value: internal-muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_MUC_DOMAIN
          value: muc.meet.{{ namespace }}.svc.{{ cluster_domain }}
        - name: XMPP_SERVER
          value: {{ prosody_name }}.{{ namespace }}.svc.{{ cluster_domain }}
{% if do_triggers == False or (opsimages | json_query("[?name=='jicofo'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='jicofo'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        name: jicofo
        resources:
          limits:
            cpu: "{{ jicofo_cpu_limit }}"
            memory: "{{ jicofo_memory_limit }}"
          requests:
            cpu: "{{ jicofo_cpu_request }}"
            memory: "{{ jicofo_memory_request }}"
        securityContext:
          privileged: true
        volumeMounts:
        - mountPath: /config
          name: data
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
      serviceAccountName: {{ jitsi_name }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ jicofo_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - name: data
        persistentVolumeClaim:
          claimName: {{ jicofo_name }}
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='jicofo'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - jicofo
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='jicofo'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
  - type: ConfigChange
{% endif %}
